input {
	udp {
		port => 5001
                codec => "json"
                type => "syslog-tacacs"
	}

}

## Add your filters / logstash plugins configuration here

filter { 
  if [type] == "syslog-tacacs" {
	fingerprint {
		source              => [ "message" ]
		method              => "SHA1"
		key                 => "Some super secret passphrase for uniqueness."
		concatenate_sources => true
	}

	json {
		source => "message"
	        skip_on_invalid_json => true
	}
	date {
		match => [
			"timereported", "yyyy-MM-dd HH:mm:ss Z"
		]
	}
        mutate {
                remove_field => [ "sysloghost"]
        }
	grok {
		patterns_dir => [ "/etc/logstash/patterns" ]
		match => [

# accounting
# 2023-03-22 14:15:55 +0100 ipa.dns.local 172.22.31.3|user1|tty1|172.22.1.12|stop||task_id=1162 timezone=CET service=shell start_time=1679490955 priv-lvl=15 cmd=show running-config <cr>
# %{USERNAME:user}|%{CISCOTTY:tty}|%{IPORHOST}|%{WORD:startstop}|task_id=%{INT:task_id}|timezone=%{WORD:timezone}|service=%{WORD:service}|start_time=%{NUMBER:start_time}|priv-lvl=%{INT:priv-lvl}|cmd=%{DATA:cmd}<cr>$
			"message",  "%{TACACS_TIMESTAMP:timereported} %{IPORHOST:nas} (%{IPORHOST:nac})\|%{USERNAME:username}\|%{CISCOTTY:tty}\|%{IPORHOST:host}\|%{WORD:startstop}\|.*\|task_id=%{INT:task_id} timezone=%{WORD:timezone} service=%{WORD:service} start_time=%{NUMBER:start_time} priv-lvl=%{INT:privlvl} cmd=%{DATA:cmd}<cr>$",
# 2023-03-23 14:52:43 +0100 ipa.dns.local 172.22.1.28|eroidl||0.0.0.0|stop||task_id=17375 service=shell priv-lvl=0 cmd=logout addr=0.0.0.0
                        "message",  "%{TACACS_TIMESTAMP:timereported} %{IPORHOST:nas} (%{IPORHOST:nac})\|%{USERNAME:username}\|%{CISCOTTY:tty}?\|%{IPORHOST:host}\|%{WORD:startstop}\|.*\|task_id=%{INT:task_id} service=%{WORD:service} priv-lvl=%{INT:privlvl} cmd=%{DATA:cmd} addr=%{IPORHOST:addr}",

# authorization
# 2023-03-22T16:09:30.504587+01:00 2023-03-22 16:09:30 +0100 ipa.dns.local 172.22.31.3|user1|tty1|172.22.1.12|p_admin|permit|shell|
                        "message",  "%{TACACS_TIMESTAMP:timereported} %{IPORHOST:nas} (%{IPORHOST:nac})\|%{USERNAME:username}\|%{CISCOTTY:tty}\|%{IPORHOST:host}\|%{WORD:profile}\|%{WORD:result}\|%{WORD:service}\|%{DATA:cmd}(<cr>)?$",

# authentication
# 2023-03-22T16:09:26.837513+01:00 2023-03-22 16:09:26 +0100 ipa.dns.local 172.22.31.3|user1|tty1|172.22.1.12|shell login failed [Invalid credentials (453)]
                        "message",  "%{TACACS_TIMESTAMP:timereported} %{IPORHOST:nas} (%{IPORHOST:nac})\|%{USERNAME:username}\|%{CISCOTTY:tty}\|%{IPORHOST:host}\|%{DATA:cmd}$"
		]
		add_tag => [ "tacacs" ]
		remove_field => [ "syslog5424_pri", "@version" ]
	}
  }
}

output {
  if "tacacs" in [tags] {
    elasticsearch {
        hosts => ["https://elastic-1:9200"]
        user => "elastic"
        password => "changeme"
        cacert => "/etc/logstash/certs/elasticsearch-ca.pem"

        manage_template => false
        index           => "%{type}-%{+YYYY.MM.dd}"
        document_type   => "%{type}"
        document_id     => "%{[event][hash]}"
    }
  }
}
